#Program reads doc_number files out of the folder text into the index
#and allows an AND-search through the text of the files

require 'socket'

@doc_index = Hash.new #each doc_id corresponds to text file
@doc_hash = Hash.new #each word corresponds to several doc_ids

#Function creates inverted index out of the files in path
#The amount of files can be limited through doc_number

def create_file_index(path,doc_number)
  i=0
  word = ""
  doc_id = 1
  text_file_words = Array.new

  filenames = Dir.entries(path)
  filenames.each do |a|
    if a != "." && a !=".."
      print "Reading file: "+a+"\n"
      @doc_index.store(doc_id,a)
      
      file = File.open("text/"+a,"r")
      text_file = file.read
      
      #Remove unwished signs
      text_file.gsub!(/\./,"")
      text_file.gsub!(/,/,"")
      text_file.gsub!(/!/,"")
      text_file.gsub!(/\?/,"")
      text_file.gsub!(/\W/,"\s")

      #Cut text in words
      text_file_words = text_file.split(/\s*\s\s*/)
      #print text_file_words.inspect

      #Build document hash (word,doc_id) index
      begin
        text_file_words.each do |w|
          if w =~ /\w+/

            if @doc_hash[w.to_sym].nil?
              file_index = Array.new
              @doc_hash.store(w.to_sym,file_index)
            else
              if @doc_hash[w.to_sym].empty?
                @doc_hash[w.to_sym] << doc_id
              end
            end

            #@doc_hash[w.to_sym].sort!
            
            if @doc_hash[w.to_sym].include?(doc_id)
            else
              @doc_hash[w.to_sym] << doc_id
            end
          end
        end
      rescue ArgumentError #Catching exceptions
        #print word+"\n"
      end
      doc_id+=1
    end
    if i < doc_number
      i+=1
    else
      return
    end
  end
end

#Function searches the index for words in Array words

def search_index(words)
  word_list = Array.new
  result = Array.new

  words.each do |w|
    if !@doc_hash[w.to_sym].nil?
      word_list << @doc_hash[w.to_sym]
    end
  end

  if !word_list.empty?
    result = word_list[0]
  end
  
  #print word_list.inspect+"\n"

  word_list.each do |l|
    result = result & l
  end

  result
end

webserver = TCPServer.new('127.0.0.1',2000)
create_file_index("text",200)
while (session = webserver.accept)
  session.print "HTTP/1.1 200/OK\r\nContent-type:text/html\r\n\r\n"
  request = session.gets
  #print request
  trimmedrequest = request.gsub(/GET\ \//,'').gsub(/\ HTTP.*/,'')
  getquery = trimmedrequest.chomp

  if getquery != ""

    #Extracts words out of query
    sentence = getquery.gsub(/word=/,"").gsub(/\?/,"\s")
    searchwords = sentence.split(/\s*\s\s*/)

    #Performs search
    found_in = search_index(searchwords)

    #Presentation of search results
    session.print "Found #{found_in.length} Results in this documents:<br><br><br>"
    found_in.each do |f|
      file = File.open("text/"+@doc_index[f],"r")
      text = file.read
      session.print ""+@doc_index[f]+"<br>----------------------------------------------------------------------------------------------------------------<br><br>"
      searchwords.each do |sw|
        text.gsub!(/\s#{sw}[\s\.\,\:]/," <font color=\"red\" size=\"10\">#{sw}</font> ")
      end
      session.print "<br>"+text+"<br><br>----------------------------------------------------------------------------------------------------------------<br>"
    end
  else
    session.print "Please type your GET query and press ENTER<br>"
  end
  session.close
end